blob: 4386b985bb068cefff8cbe0963df05408451fe8d [file] [log] [blame]
Patrick Williamsf1e5d692016-03-30 15:21:19 -05001#!/bin/sh
Patrick Williamsc124f4f2015-09-15 14:41:29 -05002
Andrew Geissler82c905d2020-04-13 13:39:40 -05003export LC_ALL=en_US.UTF-8
4#Make sure at least one python is installed
5INIT_PYTHON=$(which python3 2>/dev/null )
6[ -z "$INIT_PYTHON" ] && INIT_PYTHON=$(which python2 2>/dev/null)
7[ -z "$INIT_PYTHON" ] && echo "Error: The SDK needs a python installed" && exit 1
8
9# Remove invalid PATH elements first (maybe from a previously setup toolchain now deleted
10PATH=`$INIT_PYTHON -c 'import os; print(":".join(e for e in os.environ["PATH"].split(":") if os.path.exists(e)))'`
Patrick Williamsd8c66bc2016-06-20 12:57:21 -050011
Brad Bishop6e60e8b2018-02-01 10:27:11 -050012tweakpath () {
13 case ":${PATH}:" in
14 *:"$1":*)
15 ;;
16 *)
17 PATH=$PATH:$1
18 esac
19}
20
21# Some systems don't have /usr/sbin or /sbin in the cleaned environment PATH but we make need it
22# for the system's host tooling checks
23tweakpath /usr/sbin
24tweakpath /sbin
25
Patrick Williamsc124f4f2015-09-15 14:41:29 -050026INST_ARCH=$(uname -m | sed -e "s/i[3-6]86/ix86/" -e "s/x86[-_]64/x86_64/")
27SDK_ARCH=$(echo @SDK_ARCH@ | sed -e "s/i[3-6]86/ix86/" -e "s/x86[-_]64/x86_64/")
28
Andrew Geissler4c19ea12020-10-27 13:52:24 -050029INST_GCC_VER=$(gcc --version 2>/dev/null | sed -ne 's/.* \([0-9]\+\.[0-9]\+\)\.[0-9]\+.*/\1/p')
Brad Bishop6e60e8b2018-02-01 10:27:11 -050030SDK_GCC_VER='@SDK_GCC_VER@'
31
Patrick Williamsc124f4f2015-09-15 14:41:29 -050032verlte () {
33 [ "$1" = "`printf "$1\n$2" | sort -V | head -n1`" ]
34}
35
36verlt() {
37 [ "$1" = "$2" ] && return 1 || verlte $1 $2
38}
39
40verlt `uname -r` @OLDEST_KERNEL@
41if [ $? = 0 ]; then
42 echo "Error: The SDK needs a kernel > @OLDEST_KERNEL@"
43 exit 1
44fi
45
46if [ "$INST_ARCH" != "$SDK_ARCH" ]; then
47 # Allow for installation of ix86 SDK on x86_64 host
48 if [ "$INST_ARCH" != x86_64 -o "$SDK_ARCH" != ix86 ]; then
Patrick Williamsc0f7c042017-02-23 20:41:17 -060049 echo "Error: Incompatible SDK installer! Your host is $INST_ARCH and this SDK was built for $SDK_ARCH hosts."
Patrick Williamsc124f4f2015-09-15 14:41:29 -050050 exit 1
51 fi
52fi
53
Patrick Williamsd8c66bc2016-06-20 12:57:21 -050054if ! xz -V > /dev/null 2>&1; then
55 echo "Error: xz is required for installation of this SDK, please install it first"
56 exit 1
57fi
58
Patrick Williams213cb262021-08-07 19:21:33 -050059SDK_BUILD_PATH="@SDKPATH@"
60DEFAULT_INSTALL_DIR="@SDKPATHINSTALL@"
Patrick Williamsc124f4f2015-09-15 14:41:29 -050061SUDO_EXEC=""
Patrick Williamsd8c66bc2016-06-20 12:57:21 -050062EXTRA_TAR_OPTIONS=""
Patrick Williamsc124f4f2015-09-15 14:41:29 -050063target_sdk_dir=""
64answer=""
65relocate=1
66savescripts=0
67verbose=0
Patrick Williamsd8c66bc2016-06-20 12:57:21 -050068publish=0
Patrick Williamsc0f7c042017-02-23 20:41:17 -060069listcontents=0
70while getopts ":yd:npDRSl" OPT; do
Patrick Williamsc124f4f2015-09-15 14:41:29 -050071 case $OPT in
72 y)
73 answer="Y"
74 ;;
75 d)
76 target_sdk_dir=$OPTARG
77 ;;
78 n)
79 prepare_buildsystem="no"
80 ;;
Patrick Williamsd8c66bc2016-06-20 12:57:21 -050081 p)
82 prepare_buildsystem="no"
83 publish=1
84 ;;
Patrick Williamsc124f4f2015-09-15 14:41:29 -050085 D)
86 verbose=1
87 ;;
88 R)
89 relocate=0
90 savescripts=1
91 ;;
92 S)
93 savescripts=1
94 ;;
Patrick Williamsc0f7c042017-02-23 20:41:17 -060095 l)
96 listcontents=1
97 ;;
Patrick Williamsc124f4f2015-09-15 14:41:29 -050098 *)
Andrew Geisslerd1e89492021-02-12 15:35:20 -060099 echo "Usage: $(basename "$0") [-y] [-d <dir>]"
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500100 echo " -y Automatic yes to all prompts"
101 echo " -d <dir> Install the SDK to <dir>"
102 echo "======== Extensible SDK only options ============"
103 echo " -n Do not prepare the build system"
Patrick Williamsd8c66bc2016-06-20 12:57:21 -0500104 echo " -p Publish mode (implies -n)"
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500105 echo "======== Advanced DEBUGGING ONLY OPTIONS ========"
106 echo " -S Save relocation scripts"
107 echo " -R Do not relocate executables"
108 echo " -D use set -x to see what is going on"
Patrick Williamsc0f7c042017-02-23 20:41:17 -0600109 echo " -l list files that will be extracted"
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500110 exit 1
111 ;;
112 esac
113done
114
Andrew Geisslerd1e89492021-02-12 15:35:20 -0600115payload_offset=$(($(grep -na -m1 "^MARKER:$" "$0"|cut -d':' -f1) + 1))
Patrick Williamsc0f7c042017-02-23 20:41:17 -0600116if [ "$listcontents" = "1" ] ; then
Brad Bishopc342db32019-05-15 21:57:59 -0400117 if [ @SDK_ARCHIVE_TYPE@ = "zip" ]; then
Andrew Geisslerd1e89492021-02-12 15:35:20 -0600118 tail -n +$payload_offset "$0" > sdk.zip
Brad Bishopc342db32019-05-15 21:57:59 -0400119 if unzip -l sdk.zip;then
120 rm sdk.zip
121 else
122 rm sdk.zip && exit 1
123 fi
124 else
Andrew Geisslerd1e89492021-02-12 15:35:20 -0600125 tail -n +$payload_offset "$0"| tar tvJ || exit 1
Brad Bishopc342db32019-05-15 21:57:59 -0400126 fi
Patrick Williamsc0f7c042017-02-23 20:41:17 -0600127 exit
128fi
129
Patrick Williamsf1e5d692016-03-30 15:21:19 -0500130titlestr="@SDK_TITLE@ installer version @SDK_VERSION@"
131printf "%s\n" "$titlestr"
132printf "%${#titlestr}s\n" | tr " " "="
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500133
134if [ $verbose = 1 ] ; then
135 set -x
136fi
137
138@SDK_PRE_INSTALL_COMMAND@
139
140# SDK_EXTENSIBLE is exposed from the SDK_PRE_INSTALL_COMMAND above
141if [ "$SDK_EXTENSIBLE" = "1" ]; then
142 DEFAULT_INSTALL_DIR="@SDKEXTPATH@"
Brad Bishop6e60e8b2018-02-01 10:27:11 -0500143 if [ "$INST_GCC_VER" = '4.8' -a "$SDK_GCC_VER" = '4.9' ] || [ "$INST_GCC_VER" = '4.8' -a "$SDK_GCC_VER" = '' ] || \
144 [ "$INST_GCC_VER" = '4.9' -a "$SDK_GCC_VER" = '' ]; then
145 echo "Error: Incompatible SDK installer! Your host gcc version is $INST_GCC_VER and this SDK was built by gcc higher version."
146 exit 1
147 fi
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500148fi
149
150if [ "$target_sdk_dir" = "" ]; then
151 if [ "$answer" = "Y" ]; then
152 target_sdk_dir="$DEFAULT_INSTALL_DIR"
153 else
Patrick Williamsf1e5d692016-03-30 15:21:19 -0500154 read -p "Enter target directory for SDK (default: $DEFAULT_INSTALL_DIR): " target_sdk_dir
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500155 [ "$target_sdk_dir" = "" ] && target_sdk_dir=$DEFAULT_INSTALL_DIR
156 fi
157fi
158
159eval target_sdk_dir=$(echo "$target_sdk_dir"|sed 's/ /\\ /g')
160if [ -d "$target_sdk_dir" ]; then
161 target_sdk_dir=$(cd "$target_sdk_dir"; pwd)
162else
163 target_sdk_dir=$(readlink -m "$target_sdk_dir")
164fi
165
Patrick Williamsd8c66bc2016-06-20 12:57:21 -0500166# limit the length for target_sdk_dir, ensure the relocation behaviour in relocate_sdk.py has right result.
167if [ ${#target_sdk_dir} -gt 2048 ]; then
168 echo "Error: The target directory path is too long!!!"
169 exit 1
170fi
171
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500172if [ "$SDK_EXTENSIBLE" = "1" ]; then
173 # We're going to be running the build system, additional restrictions apply
Patrick Williamsf1e5d692016-03-30 15:21:19 -0500174 if echo "$target_sdk_dir" | grep -q '[+\ @$]'; then
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500175 echo "The target directory path ($target_sdk_dir) contains illegal" \
Patrick Williamsf1e5d692016-03-30 15:21:19 -0500176 "characters such as spaces, @, \$ or +. Abort!"
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500177 exit 1
178 fi
Patrick Williamsc0f7c042017-02-23 20:41:17 -0600179 # The build system doesn't work well with /tmp on NFS
180 fs_dev_path="$target_sdk_dir"
181 while [ ! -d "$fs_dev_path" ] ; do
182 fs_dev_path=`dirname $fs_dev_path`
183 done
184 fs_dev_type=`stat -f -c '%t' "$fs_dev_path"`
185 if [ "$fsdevtype" = "6969" ] ; then
186 echo "The target directory path $target_sdk_dir is on NFS, this is not possible. Abort!"
187 exit 1
188 fi
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500189else
190 if [ -n "$(echo $target_sdk_dir|grep ' ')" ]; then
191 echo "The target directory path ($target_sdk_dir) contains spaces. Abort!"
192 exit 1
193 fi
194fi
195
196if [ -e "$target_sdk_dir/environment-setup-@REAL_MULTIMACH_TARGET_SYS@" ]; then
197 echo "The directory \"$target_sdk_dir\" already contains a SDK for this architecture."
Brad Bishop19323692019-04-05 15:28:33 -0400198 printf "If you continue, existing files will be overwritten! Proceed [y/N]? "
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500199
200 default_answer="n"
201else
Brad Bishop19323692019-04-05 15:28:33 -0400202 printf "You are about to install the SDK to \"$target_sdk_dir\". Proceed [Y/n]? "
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500203
204 default_answer="y"
205fi
206
207if [ "$answer" = "" ]; then
208 read answer
209 [ "$answer" = "" ] && answer="$default_answer"
210else
211 echo $answer
212fi
213
214if [ "$answer" != "Y" -a "$answer" != "y" ]; then
215 echo "Installation aborted!"
216 exit 1
217fi
218
219# Try to create the directory (this will not succeed if user doesn't have rights)
220mkdir -p $target_sdk_dir >/dev/null 2>&1
221
222# if don't have the right to access dir, gain by sudo
223if [ ! -x $target_sdk_dir -o ! -w $target_sdk_dir -o ! -r $target_sdk_dir ]; then
224 if [ "$SDK_EXTENSIBLE" = "1" ]; then
225 echo "Unable to access \"$target_sdk_dir\", will not attempt to use" \
226 "sudo as as extensible SDK cannot be used as root."
227 exit 1
228 fi
229
230 SUDO_EXEC=$(which "sudo")
231 if [ -z $SUDO_EXEC ]; then
232 echo "No command 'sudo' found, please install sudo first. Abort!"
233 exit 1
234 fi
235
236 # test sudo could gain root right
237 $SUDO_EXEC pwd >/dev/null 2>&1
238 [ $? -ne 0 ] && echo "Sorry, you are not allowed to execute as root." && exit 1
239
240 # now that we have sudo rights, create the directory
241 $SUDO_EXEC mkdir -p $target_sdk_dir >/dev/null 2>&1
242fi
243
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500244printf "Extracting SDK..."
Brad Bishopc342db32019-05-15 21:57:59 -0400245if [ @SDK_ARCHIVE_TYPE@ = "zip" ]; then
Andrew Geisslerd1e89492021-02-12 15:35:20 -0600246 tail -n +$payload_offset "$0" > sdk.zip
Brad Bishopc342db32019-05-15 21:57:59 -0400247 if $SUDO_EXEC unzip $EXTRA_TAR_OPTIONS sdk.zip -d $target_sdk_dir;then
248 rm sdk.zip
249 else
250 rm sdk.zip && exit 1
251 fi
252else
Andrew Geisslerd1e89492021-02-12 15:35:20 -0600253 tail -n +$payload_offset "$0"| $SUDO_EXEC tar mxJ -C $target_sdk_dir --checkpoint=.2500 $EXTRA_TAR_OPTIONS || exit 1
Brad Bishopc342db32019-05-15 21:57:59 -0400254fi
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500255echo "done"
256
257printf "Setting it up..."
258# fix environment paths
Patrick Williamsf1e5d692016-03-30 15:21:19 -0500259real_env_setup_script=""
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500260for env_setup_script in `ls $target_sdk_dir/environment-setup-*`; do
Patrick Williamsf1e5d692016-03-30 15:21:19 -0500261 if grep -q 'OECORE_NATIVE_SYSROOT=' $env_setup_script; then
262 # Handle custom env setup scripts that are only named
263 # environment-setup-* so that they have relocation
264 # applied - what we want beyond here is the main one
265 # rather than the one that simply sorts last
266 real_env_setup_script="$env_setup_script"
267 fi
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500268 $SUDO_EXEC sed -e "s:@SDKPATH@:$target_sdk_dir:g" -i $env_setup_script
269done
Patrick Williamsf1e5d692016-03-30 15:21:19 -0500270if [ -n "$real_env_setup_script" ] ; then
271 env_setup_script="$real_env_setup_script"
272fi
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500273
274@SDK_POST_INSTALL_COMMAND@
275
276# delete the relocating script, so that user is forced to re-run the installer
277# if he/she wants another location for the sdk
278if [ $savescripts = 0 ] ; then
279 $SUDO_EXEC rm -f ${env_setup_script%/*}/relocate_sdk.py ${env_setup_script%/*}/relocate_sdk.sh
280fi
281
Brad Bishop316dfdd2018-06-25 12:45:53 -0400282# Execute post-relocation script
283post_relocate="$target_sdk_dir/post-relocate-setup.sh"
284if [ -e "$post_relocate" ]; then
285 $SUDO_EXEC sed -e "s:@SDKPATH@:$target_sdk_dir:g" -i $post_relocate
286 $SUDO_EXEC /bin/sh $post_relocate "$target_sdk_dir" "@SDKPATH@"
287 $SUDO_EXEC rm -f $post_relocate
288fi
289
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500290echo "SDK has been successfully set up and is ready to be used."
291echo "Each time you wish to use the SDK in a new shell session, you need to source the environment setup script e.g."
Patrick Williamsf1e5d692016-03-30 15:21:19 -0500292for env_setup_script in `ls $target_sdk_dir/environment-setup-*`; do
293 echo " \$ . $env_setup_script"
294done
Patrick Williamsc124f4f2015-09-15 14:41:29 -0500295
296exit 0
297
298MARKER: